package net.kelsoncraft.test;

import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.fabric.api.entity.event.v1.EntitySleepEvents;
import net.fabricmc.fabric.api.event.player.PlayerBlockBreakEvents;
import net.fabricmc.fabric.api.event.player.UseItemCallback;
import net.fabricmc.fabric.api.item.v1.FabricItemSettings;
import net.fabricmc.fabric.api.message.v1.ServerMessageEvents;
import net.fabricmc.fabric.mixin.client.rendering.EntityRenderersMixin;
import net.kelsoncraft.test.item.CustomItems;
import net.minecraft.client.render.entity.EntityRendererFactory;
import net.minecraft.client.render.entity.LightningEntityRenderer;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.LightningEntity;
import net.minecraft.inventory.EnderChestInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.predicate.entity.LightningBoltPredicate;
import net.minecraft.text.Text;
import net.minecraft.util.TypedActionResult;
import net.minecraft.util.math.Vec3d;

public class KelsonCraftTestClient implements ClientModInitializer {
	@Override
	public void onInitializeClient() {

		// This could be useful if I wanted to run something when a player gets in or out of a bed.
		// EntitySleepEvents.START_SLEEPING
		// EntitySleepEvents.STOP_SLEEPING

		//EnderChestInventory

		// Code below came from https://www.reddit.com/r/fabricmc/comments/qyt3jg/comment/hls4vep/
		// This works, but it doesn't show the lightning strike.

		// This runs whenever a player right clicks with the ruby, which is set in the if statement
		UseItemCallback.EVENT.register((player, world, unused) ->{
			ItemStack mainHandItem = player.getMainHandStack(); // Get the item the player is holding in their main hand.
			if(player.getMainHandStack().getName().equals(Text.translatable("item.kelsoncraft-test.ruby")) && !player.isSpectator()){ // Check if item is a ruby, and if the player is not in spectator mode.
				LightningEntity lightning = new LightningEntity(EntityType.LIGHTNING_BOLT, world); // Create the lightning bolt.
				world.spawnEntity(lightning); // Spawn the lightning entity

				//player.set
				// This is how to get the player position
				Vec3d playerPos = player.getPos();
				//player.sendMessage(Text.of("Your coords are X: " + playerPos.x + " Y: " + playerPos.y + " Z: " + playerPos.z));

                // This might be a way to make the lightning render in, I'm not sure how to use the EntityRendererFactory.Context()
				//LightningEntityRenderer lightning1 = new LightningEntityRenderer(new EntityRendererFactory.Context());
			}
			return TypedActionResult.success(mainHandItem, true); // Return success and swing hand to show item use.
		});
		// This entrypoint is suitable for setting up client-specific logic, such as rendering.
	}
}