package net.kelsoncraft.test.item;

import net.fabricmc.fabric.api.item.v1.FabricItemSettings;
import net.fabricmc.fabric.api.itemgroup.v1.FabricItemGroupEntries;
import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.kelsoncraft.test.KelsonCraftTest;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroups;
import net.minecraft.item.ItemStack;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.sound.SoundEvents;
import net.minecraft.util.Hand;
import net.minecraft.util.Identifier;
import net.minecraft.util.TypedActionResult;
import net.minecraft.world.World;

public class CustomItems extends Item {

    public CustomItems(Settings settings) {
        super(settings);
    }

    public static final Item RUBY = registerItem("ruby", new Item(new FabricItemSettings()));
    public static final Item RAW_RUBY = registerItem("raw_ruby", new Item(new FabricItemSettings()));
    public static final Item CUSTOM_ITEM = registerItem("custom_item", new Item(new FabricItemSettings()));

    private static void addItemsToIngredientItemGroup(FabricItemGroupEntries entries){
        entries.add(RUBY);
        entries.add(RAW_RUBY);
        entries.add(CUSTOM_ITEM);
    }

    private static Item registerItem(String name, Item item){
        return Registry.register(Registries.ITEM, new Identifier(KelsonCraftTest.MOD_ID, name), item);
        //new CustomItem(new FabricItemSettings()));
    }

    public static void RegisterCustomItems() {
        KelsonCraftTest.LOGGER.info("Registering mod items for " + KelsonCraftTest.MOD_ID);

        ItemGroupEvents.modifyEntriesEvent(ItemGroups.INGREDIENTS).register(CustomItems::addItemsToIngredientItemGroup);
    }

/*
 * Old method of adding items.
    public static final CustomItem CUSTOM_ITEM =
            Registry.register(Registries.ITEM, new Identifier(KelsonCraftTest.MOD_ID, "custom_item"),
                    new CustomItem(new FabricItemSettings()));
*/

    // This doesn't work with the way I changed the items around
    @Override
    public TypedActionResult<ItemStack> use(World world, PlayerEntity playerEntity, Hand hand) {
        // Plays amethyst step sound when clicked.
        playerEntity.playSound(SoundEvents.BLOCK_AMETHYST_CLUSTER_STEP, 1.0F, 1.0F);
        return TypedActionResult.success(playerEntity.getStackInHand(hand));
    }
}
